#include <stdio.h>
#include <stdlib.h>

#undef DEBUG

void main(int argc, char *argv[])
{
    FILE                *infile;
    unsigned long int   money;
    char                *filename;

    printf("\n");
    printf("Save game money maxxer for Lunar Command -   May 28th, 1993\n");
    printf("   by Patch (hamell@rigel.cs.pdx.edu)    - Coder for Avalanche\n");
    printf("\n");

    if (argc < 3)
    {
	printf("Usage: lunarmax FILENAME.lun MONEY\n");
	printf("where: FILENAME - the save game to alter (w/o extension)\n");
	printf("       MONEY    - a number between 0 and 4294967295\n");
	exit(-1);
    }

    strcpy(filename,argv[1]);
    strcat(filename,".lun");
    infile = fopen(filename,"r+b");
    if (infile == NULL)
    {
	printf("Could not find save game %s!\n",filename);
	exit(-1);
    }

    money = (unsigned long int) atol(argv[2]);
    if (money == 0)
    {
	printf("Money amount is whacked!  Try a number between 0 and 4294967295\n");
	exit(-1);
    }

    fseek(infile,4100,0);
    fprintf(infile,"%c%c%c%c",
	    (unsigned char) (money & 0x000000ff),
	    (unsigned char) ((money & 0x0000ff00) >> 8),
	    (unsigned char) ((money & 0x00ff0000) >> 16),
	    (unsigned char) ((money & 0xff000000) >> 24));
    fclose(infile);

    #ifdef DEBUG
	printf("%x\n",money);
	printf("%x %x %x %x\n",
	       (unsigned char)  (money & 0x000000ff),
	       (unsigned char) ((money & 0x0000ff00) >> 8),
	       (unsigned char) ((money & 0x00ff0000) >> 16),
	       (unsigned char) ((money & 0xff000000) >> 24));
    #endif

    printf("Money set to $%lu\n\n",money);
    printf("Greets to: Zax, Leinad, Errand, Thaco, Fordpr, Robinn, Trug,\n");
    printf("           Barfman, Guildmaster, Typhoon, DrinkIN, Rikoshae,\n");
    printf("           and everyone else I forgot.\n");
}
